From 5760f824863926a2b431625d36ea10293b61a1ab Mon Sep 17 00:00:00 2001
From: Judith Mendez <jm@ti.com>
Date: Thu, 22 Jun 2023 17:54:27 -0500
Subject: [PATCH] eMMC fix

Signed-off-by: Judith Mendez <jm@ti.com>
---
 arch/arm/dts/k3-am62-main.dtsi  | 5 ++---
 arch/arm/mach-k3/am625_init.c   | 7 +++++++
 configs/am62x_evm_a53_defconfig | 2 +-
 3 files changed, 10 insertions(+), 4 deletions(-)

diff --git a/arch/arm/dts/k3-am62-main.dtsi b/arch/arm/dts/k3-am62-main.dtsi
index 4d31dba4b2..831429e97e 100644
--- a/arch/arm/dts/k3-am62-main.dtsi
+++ b/arch/arm/dts/k3-am62-main.dtsi
@@ -348,11 +348,10 @@
 		bus-width = <8>;
 		ti,clkbuf-sel = <0x7>;
 		ti,otap-del-sel-legacy = <0x0>;
-		ti,otap-del-sel-mmc-hs = <0x0>;
-		ti,otap-del-sel-ddr52 = <0x5>;
-		ti,otap-del-sel-hs200 = <0x5>;
 		ti,itap-del-sel-legacy = <0xa>;
 		ti,itap-del-sel-mmc-hs = <0x1>;
+		/delete-property/mmc-ddr-1_8v;
+		/delete-property/mmc-hs200-1_8v;
 	};
 
 	sdhci1: mmc@fa00000 {
diff --git a/arch/arm/mach-k3/am625_init.c b/arch/arm/mach-k3/am625_init.c
index d103c73770..4f54eeff82 100644
--- a/arch/arm/mach-k3/am625_init.c
+++ b/arch/arm/mach-k3/am625_init.c
@@ -25,6 +25,9 @@
 #define K3RTC_KICK0_UNLOCK_VALUE	0x83e70b13
 #define K3RTC_KICK1_UNLOCK_VALUE	0x95a4f1e0
 
+/*eMMC boot mode fix*/
+#define EMMC_BOOT      9
+
 #if defined(CONFIG_SPL_BUILD)
 
 /*
@@ -245,6 +248,10 @@ u32 spl_mmc_boot_mode(const u32 boot_device)
 
 	switch (boot_device) {
 	case BOOT_DEVICE_MMC1:
+		if (((devstat & MAIN_DEVSTAT_PRIMARY_BOOTMODE_MASK) >>
+		      MAIN_DEVSTAT_PRIMARY_BOOTMODE_SHIFT) == EMMC_BOOT)
+			return MMCSD_MODE_EMMCBOOT;
+
 		if ((bootmode_cfg & MAIN_DEVSTAT_PRIMARY_MMC_FS_RAW_MASK) >>
 		     MAIN_DEVSTAT_PRIMARY_MMC_FS_RAW_SHIFT)
 			return MMCSD_MODE_EMMCBOOT;
diff --git a/configs/am62x_evm_a53_defconfig b/configs/am62x_evm_a53_defconfig
index d9bf9a5b7d..f3af0a6e51 100644
--- a/configs/am62x_evm_a53_defconfig
+++ b/configs/am62x_evm_a53_defconfig
@@ -82,7 +82,7 @@ CONFIG_MULTI_DTB_FIT=y
 CONFIG_SPL_MULTI_DTB_FIT=y
 CONFIG_SPL_MULTI_DTB_FIT_NO_COMPRESSION=y
 CONFIG_ENV_IS_IN_MMC=y
-CONFIG_SYS_MMC_ENV_PART=1
+CONFIG_SYS_MMC_ENV_PART=2
 CONFIG_NET_RANDOM_ETHADDR=y
 CONFIG_DM=y
 CONFIG_SPL_DM=y
-- 
2.34.1

